<?php
/*
	 Class: BBCode
	Author: CyberAlien (http://www.phpbbstyles.com)
	Author: UseLess (http://forum.custombuiltsoftware.co.uk or http://www.phpbbstyles.com or http://www.phpbbstyles.co.uk)
	
	 Notes: CyberAlien (aka CA ;) ) released the enhanced bbcode parser to the public
	 	on the 31 May 2005 @ 7:38 am (for more information see the following post
	 	http://www.phpbbstyles.com/viewtopic.php?t=6107 )
	 	
	 	In this release HTML still does NOT WORK so don't even Ask.

       Version:	1.0.8
       
       Modifed: UseLess
          Date: 14 October 2006
       
       Release: 6
       
         Build: 3

   This Header: It would be nice if this header was left intact.. anything you feel you want
   		to add can be added below this or the following comment block.
   		
   		It would be nice and also appreciated. ;)

*/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
}

define("BBCODE_UID_LEN", 10);
define('BBCODE_NOSMILIES_START', '<!-- no smilies start -->');
define('BBCODE_NOSMILIES_END', '<!-- no smilies end -->');
define('AUTOURL', time());

//
// Start BBCode Class definition
//
class BBCode {
	//
	// XS BBCode Version information as used by [version] BBCode tag
	//
	var $bbcode_version = array(
			'version'	=> '1.0.8',
			'release'	=> 6,
			'build'		=> 3,
			'comment'	=> 'The I seriously hate toothache release... so expect bugs...'
		);

	var $debug_enable = false;
	
	// Set initial variable states
	var $allow_html = false;		// this should remain false, unless you want HTML allowed
	var $allow_styling = true;
	var $allow_bbcode = true;
	var $allow_smilies = true;
	var $allow_remote_urls = false;

	var $is_sig = false;
	
	var $tag = '';
	var $text = '';
	var $html = '';
	var $replaced_smilies = array();
	var $data = array();
	var $params = array();

	// Set initial counter values
	var $code_counter = 0;
	var $img_counter = 0;
	var $sig_img_limit = 0;
	var $nest_level = 1;
	var $smilie_counter = 0;
	
	// default font sizes
	var $font_size_min = 9;
	var $font_size_max = 18;
	
	// default image sizes
	var $image_size_enable = true;
	var $image_width_max = 200;
	var $image_height_max = 150;
	var $sig_img_width_max = 330;
	var $sig_img_height_max = 85;
	
	// maximum smilies in post, value set from that held in board_config array
	var $max_smiles;
	
	// Array of allowed BBCodes
	var $allowed_bbcode = array(
		'version' => array(
			'nested'	=> false,
			'inurl'		=> false,
			'allow_empty'	=> true,
		),
		// simple tags
		'b'	=> array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		), 
		'i'	=> array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		),
		'u'	=> array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		),
		'strong' => array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		),
		'em'	=> array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		),
		'span'	=> array(
			'nested'	=> true,
			'inurl'		=> true,
		),
		// size
		'size' => array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		),
		// image
		'img'	=> array(
			'nested'	=> false,
			'inurl'		=> true,
		),
		// color
		'color' => array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		),
		// urls
		'url'	=> array(
			'nested'	=> false,
			'inurl'		=> false,
		),
		'a'	=> array(
			'nested'	=> false,
			'inurl'		=> false,
		),
		'email'	=> array(
			'nested'	=> false,
			'inurl'		=> false,
			'live_email'	=> true,
		),
		// lists
		'list'	=> array(
			'nested'	=> true,
			'inurl'		=> false,
		),
		'ul'	=> array(
			'nested'	=> true,
			'inurl'		=> false,
		),
		'ol'	=> array(
			'nested'	=> true,
			'inurl'		=> false,
		),
		'*'	=> array(
			'nested'	=> true,
			'inurl'		=> false,
		),
		'li'	=> array(
			'nested'	=> true,
			'inurl'		=> false,
		),
		// quote
		'quote'	=> array(
			'nested'	=> true,
			'nest_level'	=> 2,
			'inurl'		=> false,
		),
		// code
		'code'	=> array(
			'nested'	=> false,
			'inurl'		=> false,
		),
		// spoil
		'spoil' => array(
			'nested'	=> false,
			'nest_level'	=> 0,		// not really required as nesting is not allowed...
			'inurl'		=> false,
			'allow_empty'	=> false,
		),
		// spoiler
		'spoiler' => array(
			'nested'	=> false,
			'inurl'		=> false,
			'allow_empty'	=> false,
		),
		// you
		'you' => array(
			'nested'	=> false,
			'inurl'		=> false,
			'allow_empty'	=> true,
		),
		// flash  
		'flash' => array(  
			'nested'	=> false,
			'inurl'		=> false,  
			'allow_empty'	=> true,  
		),
		// align  
		'align' => array(    
			'nested'	=> false,
			'inurl'		=> false,    
			'allow_empty'	=> false,    
		),  
		// hide  
		'hide' => array(    
			'nested'	=> false,    
			'inurl'		=> false,    
			'allow_empty'	=> false,    
		),  					
		// marquee  
		'marquee' => array(    
			'nested'	=> false,  
			'inurl'		=> false,  
			'allow_empty'	=> false,  
		),  
		// marquee short  
		'marq' => array(    
			'nested'	=> false,  
			'inurl'		=> false,  
			'allow_empty'	=> false,  
		),  
		// strikethrough  
		's' => array(    
			'nested'	=> true,  
			'inurl'		=> true,  
			'allow_empty'	=> false,  
		),  
		// hr  
		'hr' => array(    
			'nested'	=> false,    
			'inurl'		=> false,    
			'allow_empty'	=> true,    
		),  
		// sub  
		'sub' => array(    
			'nested'	=> false,    
			'inurl'		=> false,    
			'allow_empty'	=> false,    
		),  
		// sup  
		'sup' => array(    
			'nested'	=> false,    
			'inurl'		=> false,    
			'allow_empty'	=> false,    
		),  
		// overline  
		'ovl' => array(    
			'nested'	=> false,    
			'inurl'		=> false,    
			'allow_empty'	=> false,    
		),  
		// simple table  
		'table' => array(  
			'nested'	=> true,  
			'nest_level'	=> 2,
			'inurl'		=> false,  
			'allow_empty'	=> false,  
		),  
		// countdown  
		'countdown' => array(  
			'nested'	=> false,  
			'inurl'		=> false,  
			'allow_empty'	=> true,  
		),  
		// youtube  
		'youtube' => array(  
			'nested'	=> false,  
			'inurl'		=> false,  
			'allow_empty'	=> true,  
		),  
		// search  
		'search' => array(  
			'nested'	=> true,  
			'inurl'		=> false,  
			'allow_empty'	=> false,    
		), 
		// tab  
		'tab' => array(  
			'nested'	=> true,  
			'inurl'		=> false,  
			'allow_empty'	=> true,    
		), 
		// tab  
		'rquote' => array(  
			'nested'	=> false,  
			'inurl'		=> false,  
			'allow_empty'	=> true,    
		), 
	);
	
	// Array of HTML tags
	var $allowed_html = array(
		// simple tags
		'b'	=> array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		), 
		'i'	=> array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		),
		'u'	=> array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		),
		'strong' => array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		),
		'em'	=> array(
			'nested'	=> true,
			'inurl'		=> true,
			'allow_empty'	=> false,
		),
		'span'	=> array(
			'nested'	=> true,
			'inurl'		=> true,
		),
		// url
		'a'	=> array(
			'nested'	=> false,
			'inurl'		=> false,
		),
		// lists
		'ul'	=> array(
			'nested'	=> true,
			'inurl'		=> false,
		),
		'ol'	=> array(
			'nested'	=> true,
			'inurl'		=> false,
		),
		'li'	=> array(
			'nested'	=> true,
			'inurl'		=> false,
		),
		// quote
		'blockquote'	=> array(
			'nested'	=> true,
			'nest_level'	=> 1,
			'inurl'		=> false,
		),
	);

	var $allowed_smilies = array(
		array(
			'code'		=> ':wink:',
			'replace'	=> '(wink)',
		),
		array(
			'code'		=> ';)',
			'replace'	=> '(smile1)',
		),
		array(
			'code'		=> ':)',
			'replace'	=> '(smile2)',
		),
	);

	/**
	 *	Process bbcode/html tag. 
	 *	This is the only function you would want to modify to add your own bbcode/html
	 *	tags.
	 *	Note: this bbcode parser doesn't make any differece of bbcode and html, so <b>
	 *	and [b] are treated exactly same way
	 */
	function process_tag(&$item)
	{
		global $board_config, $lang, $phpbb_root_path, $phpEx;

		$tag = $item['tag'];
		$start = substr($this->text, $item['start'], $item['start_len']);
		$end = substr($this->text, $item['end'], $item['end_len']);
		$content = substr($this->text, $item['start'] + $item['start_len'], $item['end'] - $item['start'] - $item['start_len']);
		$error = array(
			'valid'		=> false,
			'start'		=> $this->process_text($start),
			'end'		=> $this->process_text($end)
			);
		if(isset($item['valid']) && $item['valid'] == false)
		{
			return $error;
		}
		// check if empty item is allowed
		if(!strlen($content))
		{
			$allow_empty = true;
			if($item['is_html'] && isset($this->allowed_html[$tag]['allow_empty']) && !$this->allowed_html[$tag]['allow_empty'])
			{
				$allow_empty = false;
			}
			if(!$item['is_html'] && isset($this->allowed_bbcode[$tag]['allow_empty']) && !$this->allowed_bbcode[$tag]['allow_empty'])
			{
				$allow_empty = false;
			}
			if(!$allow_empty)
			{
				return array(
						'valid'	=> true,
						'html'	=> '',
						'end'	=> '',
						'allow_nested' => false,
					);
			}
		}
		// check if nested item is allowed
		if($item['iteration'])
		{
			if($item['is_html'] && !$this->allowed_html[$tag]['nested'])
			{
				return $error;
			}
			if(!$item['is_html'] && !$this->allowed_bbcode[$tag]['nested'])
			{
				return $error;
			}
			if( isset($this->allowed_bbcode[$tag]['nest_level']) && $this->allowed_bbcode[$tag]['nested'])
			{
				$this->nest_level = intval($this->allowed_bbcode[$tag]['nest_level']);
			}
		}

		/**
		 *	Simple tags: B, U, I, EM, STRONG, SPAN
		 */
		if($tag === 'b' || $tag === 'i' || $tag === 'u' || $tag === 'em' || $tag === 'strong' || $tag === 'span')
		{
			$extras = $this->allow_styling ? array('style', 'class') : array();
			$html = '<' . $tag . $this->add_extras($item['params'], $extras) . '>';
			return array(
				'valid'		=> true,
				'start'		=> $html,
				'end'		=> '</' . $tag . '>'
				);
		}

		/**
		 *  Output XS BBCode Parser Version info...
		 */
		if($tag === 'version')
		{
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			// title  
			$title = sprintf($lang['xs_bbc_version'], $this->bbcode_version['version'], $this->bbcode_version['release'], $this->bbcode_version['build']);  
			// generate html  
			$table_id = substr(md5($content . mt_rand()), 0, 8);
			$str = '<div class="minitable">';
			$str .= '<div class="minitable-header" id="tablehdr2_' . $table_id . '" style="position: relative;"><div class="minitable-hideme">[ <a href="javascript:void(0)" onclick="ShowHide(\'table_' . $table_id . '\', \'table2_' . $table_id . '\', \'\'); ShowHide(\'tablehdr_' . $table_id . '\', \'tablehdr2_' . $table_id . '\', \'\')">' . $lang['xs_bbc_hide'] . '</a> ]</div>' . ( !empty($title) ? $title : '' ) . '</div>';
			$str .= '<div class="minitable-header" id="tablehdr_' . $table_id . '" style="position: relative; display: none;"><div class="minitable-hideme">[ <a href="javascript:void(0)" onclick="ShowHide(\'table_' . $table_id . '\', \'table2_' . $table_id . '\', \'\'); ShowHide(\'tablehdr_' . $table_id . '\', \'tablehdr2_' . $table_id . '\', \'\')">' . $lang['xs_bbc_show'] . '</a> ]</div>' . ( !empty($title) ? $title : '' ) . '</div>';
			$str .= '<div class="minitable-contents" id="table_' . $table_id . '" style="position: relative;">';
			// header
			$str .= ( (!empty($this->bbcode_version['comment'])) ? '<div align="left" width="100%" style="font-family: Verdana, Arial, sans-serif; color: #000; font-size: 12px; font-weight: normal; background-color: #f0f0ff; border-bottom: 1px solid #d0d0d0; padding: 2px;">' . $this->bbcode_version['comment'] . '</div>' : '');
			$str .= '<b>' . $lang['xs_bbc_bbcode_explain'] . '</b>: ';
			// output alloed BBCode tags
			foreach($this->allowed_bbcode as $row_item => $item_prop)
			{
				$str .= $row_item . ', ';
			}
			$str = substr($str, 0, strlen($str)-2);
			$str .= '<br />';
			list($major_ver, $minor_ver, $revision) = explode('.', $this->bbcode_version['version']);
			if( $major_ver >= 1 && $revision >= 7)
			{
				if ($handle = @opendir($phpbb_root_path . 'includes/geshi/'))
				{
					$file_list = array();
					while (false !== ($file = @readdir($handle)))
					{ 
						$fileinfo = pathinfo($file);
						if ($file != "." && $file != ".." && strtolower($fileinfo['extension']) == 'php' )
						{ 
							$file_list[] = substr($file, 0, strpos($file, '.'));
						}
					}
					@closedir($handle);
					sort($file_list);
					$str .= '<br /><b>' . $lang['xs_bbc_supported_syntax'] . '</b>: ';
					for($i = 0; $i < count($file_list); $i++)
					{
						$str .= $file_list[$i] . ( ($i < count($file_list)-1) ? ', ' : '');
					}
				}
			}
/*
			$str .= '<br /><br />';
			$str .= '<b>' . $lang['xs_bbc_html_explain'] . '</b>: ';
			// output allowed HTML Tags
			foreach($this->allowed_html as $row_item => $item_prop)
			{
				$str .= $row_item . ', ';
			}
*/
			$str .= '</div></div>';
			return array(  
				'valid'		=> true,  
				'html'		=> $str,  
				'allow_nested'	=> false
			);  
		}

		/**
		 *	IMG
		 */
		if($tag === 'img')
		{
			if($this->is_sig)
			{
				if(!$this->sig_img_limit)
				{
					return $error;
				}
				if($this->img_counter >= $this->sig_img_limit)
				{
					return $error;
				}
				$this->img_counter++;
			}
			// main parameters
			$params = array(
				'src'	=> false,
				'alt'	=> false,
				);
			// additional allowed parameters
			$extras = $this->allow_styling ? array('width', 'height', 'border', 'style', 'class', 'title') : array('width', 'height', 'border', 'title');
			// [img=blah]blah2[/img]
			if(isset($item['params']['param']))
			{
				$params['src'] = $item['params']['param'];
				$params['alt'] = $content;
				// check if url is local
				$url_local = $this->check_url($params['src'], 'local');
				$allowed_url = $this->check_url($params['src'], 'allowed');
				
				if( !$this->allow_remote_urls && !($url_local || $allowed_url) )
				{
					if( $this->is_sig )
					{
						// we have an image in a sig, so do nothing
					}
					else
					{
						// we have an image in a post with a URL that
						// is not allowed or is not local
						return $error;
					}
				}
			}
			// [img src=blah alt=blah width=123][/img]
			elseif(isset($item['params']['src']))
			{
				$params['src'] = $item['params']['src'];
				$params['alt'] = isset($item['params']['alt']) ? $item['params']['alt'] : $content;
				// check if url is local
				$url_local = $this->check_url($params['src'], 'local');
				$allowed_url = $this->check_url($params['src'], 'allowed');
				
				if( !$this->allow_remote_urls && !($url_local || $allowed_url) )
				{
					if( $this->is_sig )
					{
						// we have an image in a sig, so do nothing
					}
					else
					{
						// we have an image in a post with a URL that
						// is not allowed or is not local
						return $error;
					}
				}

				for($i=0; $i<count($extras); $i++)
				{
					if(!empty($item['params'][$extras[$i]]))
					{
						if($extras[$i] === 'style')
						{
							$style = $this->valid_style($item['params']['style']);
							if($style !== false)
							{
								$params['style'] = $style;
							}
						}
						else
						{
							$params[$extras[$i]] = $item['params'][$extras[$i]];
						}
					}
				}
			}
			// [img]blah[/img], [img width=blah]blah[/img]
			elseif(!empty($content))
			{
				$params['src'] = $content;
				$params['alt'] = isset($item['params']['alt']) ? $item['params']['alt'] : (isset($params['title']) ? $params['title'] : '');
				// check if url is local
				$url_local = $this->check_url($params['src'], 'local');
				$allowed_url = $this->check_url($params['src'], 'allowed');
				
				if( !$this->allow_remote_urls && !($url_local || $allowed_url) )
				{
					if( $this->is_sig )
					{
						// we have an image in a sig, so do nothing
					}
					else
					{
						// we have an image in a post with a URL that
						// is not allowed or is not local
						return $error;
					}
				}

				for($i=0; $i<count($extras); $i++)
				{
					if(!empty($item['params'][$extras[$i]]))
					{
						if($extras[$i] === 'style')
						{
							$style = $this->valid_style($item['params']['style']);
							if($style !== false)
							{
								$params['style'] = $style;
							}
						}
						else
						{
							$params[$extras[$i]] = $item['params'][$extras[$i]];
						}
					}
				}
			}
			// generate html
			$html = '<img';
			foreach($params as $var => $value)
			{
				$html .= ' ' . $var . '="' . $this->process_text($value) . '"';
			}
			if(!isset($params['title']))
			{
				$html .= ' title="' . $this->process_text($params['alt']) . '"';
			}
			if( $this->image_size_enable )
			{
				if( $this->is_sig )
				{
					$html .= ' onload="if(this.width>' . $this->sig_img_width_max . '){this.width=' . $this->sig_img_width_max . ';} if(this.height>' . $this->sig_img_height_max . '){this.height=' . $this->sig_img_height_max . ';}" onclick="if(this.width>=' .$this->sig_img_width_max . ' || this.height>=' . $this->sig_img_height_max . '){window.open(\'' . $params['src'] . '\', \'_blank\'); return false;}"';
				}
				else
				{
					$html .= ' onload="if(this.width>' . $this->image_width_max . '){this.width=' . $this->image_width_max . ';} if(this.height>' . $this->image_height_max . '){this.height=' . $this->image_height_max . ';}" onclick="if(this.width>=' .$this->image_width_max . ' || this.height>=' . $this->image_height_max . '){window.open(\'' . $params['src'] . '\', \'_blank\'); return false;}"';
				}
			}
			$html .= ' />';
			// add url
			if(empty($item['inurl']))
			{
				$html = '<a href="' . $params['src'] . '" target="_blank" title="Click to open image in new window">' . $html . '</a>';
			}
			return array(
				'valid'			=> true,
				'html'			=> $html,
				'allow_nested'	=> false,
			);
		}

		/**
		 *	LIST
		 */
		if($tag === 'list' || $tag === 'ul' || $tag === 'ol')
		{
			if($this->is_sig)
			{
				return $error;
			}
			$extras = $this->allow_styling ? array('style', 'class') : array();
			// check if nested tags are all [*]
			$nested_count = 0;
			for($i=0; $i<count($item['items']); $i++)
			{
				$tag2 = $item['items'][$i]['tag'];
				if($tag2 === '*' || $tag2 === 'li')
				{
					$nested_count ++;
				}
			}
			if(!$nested_count)
			{
				// no <li> items. return error
				return $error;
			}
			// replace "list" with html tag
			if($tag === 'list')
			{
				if(isset($item['params']['param']) || isset($item['params']['type']))
				{
					$tag = 'ol';
				}
				else
				{
					$tag = 'ul';
				}
			}
			// valid tag. process subitems to make sure there are no extra items and remove all code between elements
			$last_item = false;
			for($i=0; $i<count($item['items']); $i++)
			{
				$item2 = &$item['items'][$i];
				$tag2 = $item2['tag'];
				if($tag2 === '*' || $tag2 === 'li')
				{
					// mark as valid
					$item2['list_valid'] = true;
					if($last_item === false)
					{
						// change start position to end of [list]
						$pos2 = $item2['start'] + $item2['start_len'];
						$item2['start'] = $pos;
						$item2['start_len'] = $pos2 - $pos;
						$item2['first_entry'] = true;
					}
					$last_item = &$item['items'][$i];
				}
			}
			// generate html
			$html = '<' . $tag;
			if(isset($item['params']['param']))
			{
				$html .= ' type="' . htmlspecialchars($item['params']['param']) . '"';
			}
			elseif(isset($item['params']['type']))
			{
				$html .= ' type="' . htmlspecialchars($item['params']['type']) . '"';
			}
			$html .= $this->add_extras($item['params'], $extras) . '>';
			return array(
				'valid'		=> true,
				'start'		=> $html,
				'end'		=> '</li></' . $tag . '>'
				);
		}

		/**
		 *	[*], LI
		 */
		if($tag === '*' || $tag === 'li')
		{
			if($this->is_sig)
			{
				return $error;
			}
			$extras = $this->allow_styling ? array('style', 'class') : array();
			// if not marked as valid return error
			if(empty($item['list_valid']))
			{
				return $error;
			}
			$html = '<li';
			if(empty($item['first_entry']))
			{
				// add closing tag for previous list entry
				$html = '</li>' . $html;
			}
			$html .= $this->add_extras($item['params'], $extras) . '>';
			return array(
				'valid'	=> true,
				'start'	=> $html,
				'end'	=> '',
			);
		}

		/**
		 *	COLOR
		 */
		if($tag === 'color')
		{
			if($this->is_sig)
			{
				return $error;
			}
			$extras = $this->allow_styling ? array('class') : array();
			$color = '';
			if(isset($item['params']['param']))
			{
				$color = $item['params']['param'];
			}
			elseif(isset($item['params']['color']))
			{
				$color = $item['params']['color'];
			}
			else
			{
				return $error;
			}
			$color = $this->valid_color($color);
			if($color === false)
			{
				return $error;
			}
			$html = '<span style="' . ($this->allow_styling && isset($item['params']['style']) ? htmlspecialchars($this->valid_style($item['params']['style'], '')) : '') . 'color: ' . $color . ';"' . $this->add_extras($item['params'], $extras) . '>';
			return array(
				'valid'	=> true,
				'start'	=> $html,
				'end'	=> '</span>',
			);
		}

		/**
		 *	SIZE
		 */
		if($tag === 'size')
		{
			$extras = $this->allow_styling ? array('class') : array();
			$size = 0;
			if(isset($item['params']['param']))
			{
				$size = intval($item['params']['param']);
			}
			elseif(isset($item['params']['size']))
			{
				$size = intval($item['params']['size']);
			}
			else
			{
				return $error;
			}
			if($size > 0 && $size < 5)
			{
				// vBulletin-style sizes
				switch($size)
				{
					case 1: $size = 9; break;
					case 2: $size = 12; break;
					case 3: $size = 15; break;
					case 4: $size = 18; break;
				}
			}
			if($size < $this->font_size_min || $size > $this->font_size_max)
			{
				return $error;
			}
			$html = '<span style="' . ($this->allow_styling && isset($item['params']['style']) ? htmlspecialchars($this->valid_style($item['params']['style'], '')) : '') . 'font-size: ' . $size . 'px;"' . $this->add_extras($item['params'], $extras) . '>';
			return array(
				'valid'	=> true,
				'start'	=> $html,
				'end'	=> '</span>',
			);
		}

		/**
		 *	URL, A
		 */
		if($tag === 'url' || $tag === 'a')
		{
			$extras = $this->allow_styling ? array('style', 'class', 'name', 'title') : array('name', 'title');
			$allow_nested = true;
			$strip_text = false;
			$show_content = true;
			$url = '';
			// get url
			if(!empty($item['params']['param']))
			{
				$url = $item['params']['param'];
			}
			elseif(!empty($item['params']['href']))
			{
				$url = $item['params']['href'];
			}
			elseif(!$item['is_html'])
			{
				$url = $content;
				$allow_nested = false;
				$strip_text = true;
			}
			else
			{
				return $error;
			}
			if($url === $content && strlen($content) > 64)
			{
				$content = substr($content, 0, 35) . '...' . substr($content, strlen($content) - 15);
				$show_content = false;
			}
			// check if its email
			if(substr(strtolower($url), 0, 7) === 'mailto:')
			{
				$item['tag'] = 'email';
				return $this->process_tag($item);
			}
			// check for invalid urls
			$url = $this->valid_url($url, '');
			if(empty($url))
			{
				return $error;
			}
			// check nested items
			if(!$allow_nested)
			{
				for($i=0; $i<count($item['items']); $i++)
				{
					$item['items'][$i]['valid'] = false;
				}
			}
			else
			{
				for($i=0; $i<count($item['next']); $i++)
				{
					$tag2 = $item['next'][$i]['tag'];
					$is_html = $item['next'][$i]['item']['is_html'];
					$item['next'][$i]['item']['inurl'] = true;
					if($is_html && !$this->allowed_html[$tag2]['inurl'])
					{
						$item['next'][$i]['item']['valid'] = false;
					}
					if(!$is_html && !$this->allowed_bbcode[$tag2]['inurl'])
					{
						$item['next'][$i]['item']['valid'] = false;
					}
				}
			}
			// check for incomplete url
			if(substr(strtolower($url), 0, 4) === 'www.')
			{
				$url = 'http://' . $url;
			}
			// remove extra characters at the end
			$last_char = substr($url, strlen($url) - 1);
			$last_char_i = ord($last_char);
			if(($last_char_i > 32 && $last_char_i < 47) || ($last_char_i > 57 && $last_char_i < 65))
			{
				$url = substr($url, 0, strlen($url) - 1);
			}
			// check if url is local and allowed
			$url_local = $this->check_url($url, 'local');
			$allowed_url = $this->check_url($url, 'allowed');
			// check remote urls enabled
			if( $this->allow_remote_urls || ($url_local || $allowed_url) )
			{
				$target = ' target="' . ( ($url_local == TRUE && $allowed_url == FALSE) ? '_self' : ( ($url_local == FALSE && $allowed_url == TRUE) ? '_blank' : ( ($this->allow_remote_urls == TRUE && $url_local == FALSE && $allowed_url == FALSE) ? '_blank' : '' ))) . '"';
				// generate html
				$html = '<a' . ($this->allow_styling && isset($item['params']['class']) ? '' : ' class="post-url"') . ' href="' . htmlspecialchars($url) . '"' . $target . $this->add_extras($item['params'], $extras) . '>';
			}
			else
			{
				return array(
					'valid'	=> false,
					'start'	=> '',
					'end'	=> '',
				);

			}
			
			if($show_content)
			{
				return array(
					'valid'	=> true,
					'start'	=> $html,
					'end'	=> '</a>',
				);
			}
			else
			{
				return array(
					'valid'	=> true,
					'html'	=> $html . $content . '</a>',
					'allow_nested' => false,
					);
			}
		}

		/**
		 *	EMAIL
		 */
		if($tag === 'email')
		{
			if(!$this->allowed_bbcode[$tag]['live_email'])
			{
				return $error;
			}
			$extras = $this->allow_styling ? array('style', 'class', 'name', 'title') : array('name', 'title');
			$allow_nested = true;
			$strip_text = false;
			$url = '';
			// get url
			if(!empty($item['params']['param']))
			{
				$url = $item['params']['param'];
			}
			elseif(!empty($item['params']['href']))
			{
				$url = $item['params']['href'];
			}
			elseif(!empty($item['params']['addr']))
			{
				$url = $item['params']['addr'];
			}
			else
			{
				$url = $content;
				$pos = strpos($url, '?');
				if($pos)
				{
					$content = substr($url, 0, $pos);
				}
				if(substr(strtolower($url), 0, 7) === 'mailto:')
				{
					$content = substr($content, 7);
				}
				$allow_nested = false;
				$strip_text = true;
			}
			if(empty($url))
			{
				return $error;
			}
			// disable nested items
			for($i=0; $i<count($item['items']); $i++)
			{
				$item['items'][$i]['valid'] = false;
			}
			// generate html
			if(substr(strtolower($url), 0, 7) === 'mailto:')
			{
				$url = substr($url, 7);
			}
			$email = '<a' . ($this->allow_styling && isset($item['params']['class']) ? '' : ' class="post-email"') . ' href="mailto:' . htmlspecialchars($url) . '"' . $this->add_extras($item['params'], $extras) . '>' . $content . '</a>';
			$pos = strpos($url, '?');
			if($pos)
			{
				$str = substr($url, 0, $pos);
			}
			else
			{
				$str = $url;
			}
			$noscript = '<noscript>' . htmlspecialchars(str_replace(array('@', '.'), array(' [at] ', ' [dot] '), $str)) . '</noscript>';
			// make javascript from it
			$html = BBCODE_NOSMILIES_START . '<script language="JavaScript" type="text/javascript">' . "\n" . '<!--' . "\n";
			for($i=0; $i<strlen($email); $i+=5)
			{
				$str = substr($email, $i, 5);
				$html .= 'document.write(\'' . addslashes($str) . '\');' . "\n";
			}
			$html .= "\n" . '//-->' . "\n" . '</script>' . $noscript . BBCODE_NOSMILIES_END;
			return array(
				'valid'	=> true,
				'html'	=> $html,
				'allow_nested' => false,
			);
		}

		/**
		 *	QUOTE
		 */
		if($tag === 'quote' || $tag === 'blockquote')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			// check user  
			$user = '';  
			$url = '';  
			$this_page = '';  
			if(isset($item['params']['param']))  
			{  
				if(substr(strtolower($item['params']['param']), 0, 4) === 'www.')  
				{  
					$url = 'http://' . $item['params']['param'];  
				}  
				elseif(substr(strtolower($item['params']['param']), 0, 7) === 'http://')  
				{  
					$url = $item['params']['param'];  
				}  
				else  
				{  
					$user = htmlspecialchars($item['params']['param']);  
				}  
			}  
			elseif(isset($item['params']['user']))  
			{  
				$user = htmlspecialchars($item['params']['user']);  
				if(isset($item['params']['userid']))  
				{  
					$user = '<a href="profile.php?mode=viewprofile&amp;u=' . $item['params']['userid'] . '">' . $user . '</a>';  
				}  
			}  
			// generate html  
			$html = '<blockquote class="quote"';  
			if(isset($item['params']['url']) || $url)  
			{  
				if(!$url)  
				{  
					$url = $item['params']['url'];  
				}  
				// check for invalid urls  
				$url = $this->valid_url($url, '');  
				// check for incomplete url  
				if(substr(strtolower($url), 0, 4) === 'www.')  
				{  
					$url = 'http://' . $url;  
				}              
				$html .= ' cite="' . $url . '"';  
				$this_page = sprintf($lang['xs_bbc_page'], '<a href="' . $url . '" target="_blank">', '</a>');  
			}  
			elseif(isset($item['params']['post']) && intval($item['params']['post']))  
			{  
				$html .= ' cite="viewtopic.php?p=' . intval($item['params']['post']) . '#' . intval($item['params']['post']) . '"';  
				$this_post = sprintf($lang['xs_bbc_post'], '<a href="./viewtopic.php?p=' . intval($item['params']['post']) . '#' . intval($item['params']['post']) . '">', '</a>');  
			}  
			else  
			{  
				$this_post = '';  
			}  
			$html .= '>';  
			if($this_page)  
			{  
				$html .= '<div class="quote-user">' . $this_page . ':</div>';  
			}  
			elseif($user)  
			{  
				$html .= '<div class="quote-user">' . $user . ' ' . $lang['wrote'] . $this_post . ':</div>';  
			}  
			else  
			{  
				$html .= '<div class="quote-nouser">' . $lang['Quote'] . ':</div>';  
			}  
			$html .= '<div class="quote-message">';  
			return array(  
				'valid'        => true,  
				'start'        => $html,  
				'end'        => '</div></blockquote>'  
			);  
		}
		
		/**  
		 *  BBCode: code
		 *
		 *  Allowed attributes:
		 *	- start = " x "
		 *	- filename = " filename for code when downloaded "
		 *	- highlight = " line numbers to highlight seperated with , or - for consecutive lines "
		 *	- syntax = " php | asp | css " - over 70 syntax files included
		 *
		 *	- [highlight] text in line to be highlighted [/highlight]
		 */
		if($tag === 'code')
		{
			if($this->is_sig)
			{
				return $error;
			}
			// replace spaces and tabs with &nbsp;
			if(!defined('EXTRACT_CODE'))
			{
				$search = array(
						'  ',
						"\t"
					);
				$replace = array(
						' &nbsp;',
						' &nbsp; &nbsp;'
					);
				$text = str_replace($search, $replace, $this->process_text($content, false, true));
				$temp_text = explode("\n", $text);
				$load_expand = true;
				if( count($temp_text) <= 4 )
				{
					$load_expand = false;
				}
				unset($temp_text);
			}
			else
			{
				$text = $this->process_text($content, false, true);
				$search = array('[highlight]', '[/highlight]');
				$replace = array('', '');
				$text = str_replace($search, $replace, $text);
			}
			// check filename
			if(isset($item['params']['filename']))
			{
				$item['params']['file'] = $item['params']['filename'];
			}
			if(defined('EXTRACT_CODE') && $this->code_counter == EXTRACT_CODE)
			{
				$GLOBALS['code_text'] = $text;
				if(!empty($item['params']['file']))
				{
					$GLOBALS['code_filename'] = $item['params']['file'];
				}
			}
			if(substr($text, 0, 1) === "\n")
			{
				$text = substr($text, 1);
			}
			elseif(substr($text, 0, 2) === "\r\n")
			{
				$text = substr($text, 2);
			}
			$header = '';
			if(isset($item['params']['syntax']) && !defined('EXTRACT_CODE'))
			{
				$syntax = trim(htmlspecialchars($item['params']['syntax']));
				//
				// check to see if a syntax file for the specified syntax
				// actually exists... if not set $syntax to an empty string
				//
				if( !file_exists($phpbb_root_path . 'includes/geshi/' . $syntax . '.' . $phpEx) )
				{
					$syntax = '';
				}
				
				if( !empty($syntax) )
				{
					//
					// GeSHi Syntax Highlighter
					//
					$text = strtr($text, array_flip(get_html_translation_table(HTML_ENTITIES, ENT_COMPAT)));
					if( !class_exists('GeSHi') )
					{
						include($phpbb_root_path . 'includes/geshi.'.$phpEx);
					}
					$geshi =& new GeSHi($text, $syntax);
					$geshi->set_link_target('_blank');
					$geshi->set_header_type(GESHI_HEADER_NONE);
//					$geshi->enable_classes();
					$geshi->enable_line_numbers(GESHI_NO_LINE_NUMBERS, 0);
//					$geshi->set_overall_style('color: #000066; border: 1px solid #d0d0d0; background-color: #f0f0f0;', true);
					$geshi->set_line_style('font: normal normal 95% \'Courier New\', Courier, monospace; color: #003030;', 'font-weight: bold; color: #006060;', true);
//					$geshi->set_code_style('color: #000020;', 'color: #000020;');
					$geshi->set_link_styles(GESHI_LINK, 'color: #000060;');
					$geshi->set_link_styles(GESHI_HOVER, 'background-color: #f0f000;');
//					$geshi->set_header_content('The following is using ' . $syntax . ' syntax highlighting.');
//					$geshi->set_header_content_style('font-family: Verdana, Arial, sans-serif; color: #808080; font-size: 70%; font-weight: bold; background-color: #f0f0ff; border-bottom: 1px solid #d0d0d0; padding: 2px;');
					$geshi->set_footer_content('Parsed in <TIME> seconds,  using <a href="http://qbnz.com/highlighter/" target="_blank">GeSHi</a> <VERSION>');
					$geshi->set_footer_content_style('font-family: Verdana, Arial, sans-serif; color: #808080; font-size: 70%; font-weight: bold; background-color: #f0f0ff; border-top: 1px solid #d0d0d0; padding: 2px;');
					$text = $geshi->parse_code();
					// convert to list
					$search = array("\n", '[highlight]', '[/highlight]');
					$replace = array('</span></li><li class="code-row"><span class="code-row-text">', '<span class="code-row-highlight">', '</span>');
					$html = '<li class="code-row code-row-first"><span class="code-row-text">' . str_replace($search, $replace, $text) . '&nbsp;</span></li>';
					$header = '<div align="center" width="100%" style="font-family: Verdana, Arial, sans-serif; color: #808080; font-size: 12px; font-weight: bold; background-color: #f0f0ff; border-bottom: 1px solid #d0d0d0; padding: 2px;">' . sprintf($lang['xs_bbc_syntax_used'], '<span style="color: #900;">' . $syntax . '</span>') . '</div>';
				}
				else
				{
					// convert to list
					$search = array("\n", '[highlight]', '[/highlight]');
					$replace = array('&nbsp;</span></li><li class="code-row"><span class="code-row-text">', '<span class="code-row-highlight">', '</span>');
					$html = '<li class="code-row code-row-first"><span class="code-row-text">' . str_replace($search, $replace, $text) . '&nbsp;</span></li>';
				}
			}
			else
			{
				// convert to list
				$search = array("\n", '[highlight]', '[/highlight]');
				$replace = array('&nbsp;</span></li><li class="code-row"><span class="code-row-text">', '<span class="code-row-highlight">', '</span>');
				$html = '<li class="code-row code-row-first"><span class="code-row-text">' . str_replace($search, $replace, $text) . '&nbsp;</span></li>';
			}
			$str = '<li class="code-row"><span class="code-row-text">&nbsp;</span></li>';
			if(substr($html, strlen($html) - strlen($str)) === $str)
			{
				$html = substr($html, 0, strlen($html) - strlen($str));
			}
			$start = isset($item['params']['start']) ? intval($item['params']['start']) : 1;
			$can_download = !empty($GLOBALS['code_post_id']) ? $GLOBALS['code_post_id'] : 0;
			if($can_download)
			{
				$download_text = ' [ <a href="bbc_download.php?post=' . $can_download;
				if($this->code_counter)
				{
					$download_text .= '&item=' . $this->code_counter;
				}
				$download_text .= '">' . $lang['xs_bbc_download'] . '</a> ]';
			}
			else
			{
				$download_text = '';
			}
			$code_id = substr(md5($content . mt_rand()), 0, 8);
			$str = BBCODE_NOSMILIES_START . '<div class="code">';
			$str .= ( ($load_expand == true) ? "\n<script language=\"JavaScript\" type=\"text/javascript\">\n<!--\nvar id = 'SXBB_" . $this->code_counter . '_' . $code_id ."';\nSXBB[id] = new _SXBB(id);\nSXBB[id].T['select'] = '" . $lang['xs_bbc_select'] . "';\nSXBB[id].T['expand'] = '" . $lang['xs_bbc_expand'] . "';\nSXBB[id].T['contract'] = '" . $lang['xs_bbc_contract'] . "';\n//-->\n</script>\n" : '');
			$str .= '<div class="code-header" id="codehdr2_' . $code_id . '" style="position: relative;">' . $lang['Code'] . ':' . (empty($item['params']['file']) ? '' : ' (' . htmlspecialchars($item['params']['file']) . ')') . $download_text . ' [ <a href="javascript:void(0)" onclick="ShowHide(\'code_' . $code_id . '\', \'code2_' . $code_id . '\', \'\'); ShowHide(\'codehdr_' . $code_id . '\', \'codehdr2_' . $code_id . '\', \'\')">' . $lang['xs_bbc_hide'] . '</a> ]' . ( ($load_expand == true) ? '<script language="javascript" type="text/javascript">SXBB[id].writeCmd();</script>' : '') . '</div>';
			$str .= '<div class="code-header" id="codehdr_' . $code_id . '" style="position: relative; display: none;">' . $lang['Code'] . ':' . (empty($item['params']['file']) ? '' : ' (' . htmlspecialchars($item['params']['file']) . ')') . $download_text . ' [ <a href="javascript:void(0)" onclick="ShowHide(\'code_' . $code_id . '\', \'code2_' . $code_id . '\', \'\'); ShowHide(\'codehdr_' . $code_id . '\', \'codehdr2_' . $code_id . '\', \'\')">' . $lang['xs_bbc_show'] . '</a> ]</div>';
			$str .= '<div class="code-content" id="code_' . $code_id . '">';
			$str .= ( ($load_expand == true) ? "<script language=\"JavaScript\" type=\"text/javascript\">\n<!--\nSXBB[id].writeDiv();\n//-->\n</script>\n" : '');
			$html = $str . $header . '<ol class="code-list" start="' . $start . '">' . $html . '</ol>';
			// close jscript generated div
			$html .= ( ($load_expand == true) ? "<script language=\"JavaScript\" type=\"text/javascript\">\n<!--\ndocument.write('</div>');\n//-->\n</script>\n" : '');
			$html .= '</div>'; // closing code-content div
			$html .= '</div>' . BBCODE_NOSMILIES_END;
			// check highlight
			// format: highlight="1,2,3-10"
			if(isset($item['params']['highlight']))
			{
				$search = '<li class="code-row';
				$replace = '<li class="code-row code-row-highlight';
				$search_len = strlen($search);
				$replace_len = strlen($replace);
				// get highlight string
				$items = array();
				$str = $item['params']['highlight'];
				$list = explode(',', $str);
				for($i=0; $i<count($list); $i++)
				{
					$str = trim($list[$i]);
					if(strpos($str, '-'))
					{
						$row = explode('-', $str);
						if(count($row) == 2)
						{
							$num1 = intval($row[0]);
							if($num1 == 0)
							{
								$num1 = 1;
							}
							$num2 = intval($row[1]);
							if($num1 > 0 && $num2 > $num1 && ($num2 - $num1) < 256)
							{
								for($j=$num1; $j<=$num2; $j++)
								{
									$items['row' . $j] = true;
								}
							}
						}
					}
					else
					{
						$num = intval($str);
						if($num)
						{
							$items['row' . $num] = true;
						}
					}
				}
				if(count($items))
				{
					// process all lines
					$num = $start - 1;
					$pos = strpos($html, $search);
					$total = count($items);
					$found = 0;
					while($pos !== false)
					{
						$num ++;
						if(isset($items['row' . $num]))
						{
							$found ++;
							$html = substr($html, 0, $pos) . $replace . substr($html, $pos + $search_len);
							$pos += $replace_len;
						}
						else
						{
							$pos += $search_len;
						}
						$pos = $found < $total ? strpos($html, $search, $pos) : false;
					}
				}
			}
			$this->code_counter++;
			return array(
				'valid'	=> true,
				'html'	=> $html,
				'allow_nested' => false
				);
		}

		/**  
		 *  BBCode: spoil
		 */
		if($tag === 'spoil')
		{
			if($this->is_sig)
			{
				return $error;
			}
			if($item['iteration'] > $this->nest_level)
			{
				return $error;
			}
			$html = '<span class="spoil">';
			return array(
				'valid'		=> true,
				'start'		=> $html,
				'end'		=> '</span>'
				);
		}

		/**  
		 *  BBCode: spoiler
		 *
		 *  optional attributes:
		 *	- [spoiler="film name"]
		 *  will then show 'Spoiler for film name:'
		 */
		if($tag === 'spoiler')
		{
			if($this->is_sig)
			{
				return $error;
			}
			if($item['iteration'] > $this->nest_level)
			{
				return $error;
			}
			$spoil_text = '';
			if(isset($item['params']['param']))
			{
				$spoil_text = htmlspecialchars($item['params']['param']);
			}
			$spoiler_id = substr(md5($content . mt_rand()), 0, 8);
			$str = '<div class="spoiler">';
			$str .= '<div class="spoiler-header" id="spoilerhdr_' . $spoiler_id . '" style="position: relative;">' . $lang['xs_bbc_spoiler'] . ( (!empty($spoil_text)) ? ' ' . $lang['xs_bbc_spoiler_for'] . ' ' . ucwords($spoil_text) : '') . ': [ <a href="javascript:void(0)" onclick="ShowHide(\'spoiler_' . $spoiler_id . '\', \'spoiler2_' . $spoiler_id . '\', \'\'); ShowHide(\'spoilerhdr_' . $spoiler_id . '\', \'spoilerhdr2_' . $spoiler_id . '\', \'\')">' . $lang['xs_bbc_show'] . '</a> ]</div>';
			$str .= '<div class="spoiler-header" id="spoilerhdr2_' . $spoiler_id . '" style="position: relative; display: none;">' . $lang['xs_bbc_spoiler'] . ( (!empty($spoil_text)) ? ' for ' . ucwords($spoil_text) : '') . ': [ <a href="javascript:void(0)" onclick="ShowHide(\'spoiler_' . $spoiler_id . '\', \'spoiler2_' . $spoiler_id . '\', \'\'); ShowHide(\'spoilerhdr_' . $spoiler_id . '\', \'spoilerhdr2_' . $spoiler_id . '\', \'\')">' . $lang['xs_bbc_hide'] . '</a> ]</div>';
			$str .= '<div class="spoiler-content" id="spoiler2_' . $spoiler_id . '" style="position: relative; display: none;">' . $html;
			return array(
				'valid'		=> true,
				'start'		=> $str,
				'end'		=> '</div></div>'
				);
		}

		/**  
		 *  BBCode: you
		 *
		 *  Allowed attributes:
		 *	- style="x"
		 *	- class="x"
		 */
		if($tag === 'you')
		{
			if($this->is_sig)
			{
				return $error;
			}
			if($item['iteration'] > $this->nest_level)
			{
				return $error;
			}
			if( isset($item['params']['style']) )
			{
				$style = $this->valid_style($item['params']['style']);
				if($style === false)
				{
					return $error;
				}
			}
			global $userdata;
			$extras = $this->allow_styling ? array('style', 'class') : array();
			$str = '<span' . $this->add_extras($item['params'], $extras) . '>' . $userdata['username'];
			return array(
				'valid'		=> true,
				'start'		=> $str,
				'end'		=> '</span>'
				);
		}

		/**  
		 *  BBCode: flash  
		 *
		 * Required Attributes:
		 *	- src = " src flash file "
		 *	- width = " pixels "
		 *	- height = " pixels "
		 *
		 * Optional Attributes:
		 *	- menu = " true | false "
		 *	- quality = " low | high | best " (these could be wrong.. ;) )
		 *	- bgcolor = " #rrggbb | colour name (i.e. red) "
		 *	- loop = " true | false "
		 *	- wmode = " transparent "
		 *	- scale = " noborder "
		 *
		 *  Code Added by kvfb97 - http://www.kvfb97.co.uk/phpbb/  
		 *
		 *  Code extended by UseLess
		 */  
		if($tag === 'flash')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			// Main params
			$params = array(
				'src' => false,
				'width' => false,
				'height' => false,
				);
			$extras = $this->allow_styling ? array('menu', 'quality', 'bgcolor', 'loop', 'wmode', 'scale') : array();
			$params['src'] = ( (isset($item['params']['src']) ) ? $item['params']['src'] : '');
			$params['width'] = ( (isset($item['params']['width']) ) ? intval($item['params']['width']) : '');
			$params['height'] = ( (isset($item['params']['height']) ) ? intval($item['params']['height']) : '');
			if( !empty($params['src']) && !empty($params['width']) && !empty($params['height']) )
			{
				$html = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="' . $params['width'] . '" height="' . $params['height'] . '" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=5,0,0,0">';
				$html .= '<param name="allowScriptAccess" value="never" />';
				$html .= '<param name="movie" value="' . $params['src'] . '" />';
				$html .= $this->add_object_extras($item['params'], $extras);
				$html .= '<embed allowScriptAccess="never" src="' . $params['src'] . '" width="' . $params['width'] . '" height="' . $params['height'] . '"' . $this->add_extras($item['params'], $extras) . ' pluginspage="http://www.macromedia.com/go/getflashplayer" type="application/x-shockwave-flash">';  
				return array(  
					'valid'		=> true,  
					'start'		=> $html,  
					'end'		=> '</embed></object>'  
				);
			}
			else
			{
				return array(  
					'valid'		=> false,  
					'start'		=> '',  
					'end'		=> ''  
				);
			}
		} 

		/**  
		 *  BBCode: align  
		 *
		 *  Code Added by kvfb97 - http://www.kvfb97.co.uk/phpbb/
		 *
		 *  Code extended by UseLess (fixed returning of entered text + bbcode tags if no align attribute was set)
		 */
		if($tag === 'align')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			$html = '<div';  
			if(isset($item['params']['param']))  
			{  
				$aligns = array('left', 'right', 'center', 'justify');
				$align = htmlspecialchars($item['params']['param']);
				if( !in_array($align, $aligns) )
				{
					$align = 'left';
				}
				$html .= ' style="text-align: ' . $align . '"';  
			}  
			else  
			{  
				return array(
					'valid'	=> true,
					'start' => '',
					'end'	=> ''
				);
			}  
			$html .= '>';  
			return array(  
				'valid'        => true,  
				'start'        => $html,  
				'end'        => '</div>'  
			);  
		}  

		/**  
		 *  BBCode: hide  
		 *
		 *  Code Added by kvfb97 - http://www.kvfb97.co.uk/phpbb/  
		 *
		 *  Code extended by UseLess
		 */  
		if($tag === 'hide')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			global $db, $topic_id, $userdata, $staff_ary;  
			$show = false;  
			if($userdata['session_logged_in'])  
			{  
				$sql = "SELECT poster_id, topic_id  
					FROM " . POSTS_TABLE . "  
					WHERE topic_id = $topic_id  
					AND poster_id = " . $userdata['user_id'];  
				$resultat = $db->sql_query($sql);  
				$show = $db->sql_numrows($resultat) ? true : false;  
			}  
			// allow admins and mods to view the hidden message even if they have
			// not replied to the post
			if( in_array($userdata['user_level'], $staff_ary) )
			{
				$show = true;
			}
			// generate html  
			$html = '<blockquote class="quote">';  
			$html .= '<div class="quote-nouser">' . $lang['xs_bbc_hide_message'] . ':</div>';  
			if(!$show)
			{  
				$html .= '<div class="quote-message">' . $lang['xs_bbc_hide_message_explain'] . '</div>';  
				$html .= '</blockquote>';
				return array(
					'valid' => true,
					'html' => $html,
					'allow_nested' => false
				);
			}
			else
			{  
				$html .= '<div class="quote-message">';  
			}  
			return array(  
				'valid'	=> true,  
				'start'	=> $html,  
				'end'	=> '</div></blockquote>'  
				);  
		}  

		/**  
		 *  BBCode: marquee
		 *
		 *  Allowed attributes:
		 *	- style="x"
		 *	- class="x"
		 *	- direction = " left | right | up | down "
		 *	- behavior = " scroll | slide | alternate "
		 *	- loop = " 1 " - default is -1 or infinite
		 *	- scrollamount = " pixels "
		 *	- scrolldelay = " milliseconds "
		 *	- width = " percentage | pixels "
		 *	- height = " percentage | pixles "
		 *
		 *  Code Added by Disturbed One - www.hvmdesign.com  
		 *
		 *  Code extended by UseLess
		 */  
		if($tag === 'marquee' || $tag === 'marq')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			if( isset($item['params']['style']) )
			{
				$style = $this->valid_style($item['params']['style']);
				if($style === false)
				{
					return $error;
				}
			}
			$params = array(
				'width' => false,
				'height' => false,
				);
			$params['width'] = ( (isset($item['params']['width']) && strpos($item['params']['width'], '%') === false) ? intval($item['params']['width']) : ( (strpos($item['params']['width'], '%') !== false) ? $item['params']['width'] : ''));
			$params['height'] = ( (isset($item['params']['height']) && strpos($item['params']['height'], '%') === false) ? intval($item['params']['height']) : ( (strpos($item['params']['height'], '%') !== false) ? $item['params']['height'] : ''));
			$extras = $this->allow_styling ? array('style', 'class', 'direction', 'behavior', 'loop', 'scrollamount', 'scrolldelay') : array();
			$marq_id = substr(md5($content . mt_rand()), 0, 8);
			
			$str = '';
			if( !empty($params['width']) )
			{
				$str .= '<div align="center">';
			}
			$str .= '<marquee id="marq_' . $marq_id . '"' . ( (!empty($params['width'])) ? ' width="' . $params['width'] . '"' : '' ) . ( (!empty($params['height'])) ? ' height="' . $params['height'] . '"' : '' ) . $this->add_extras($item['params'], $extras) . '>';  
			return array(  
				'valid'        => true,  
				'start'        => $str,  
				'end'        => '</marquee>' . ( (!empty($params['width'])) ? '</div>' : '')  
			);  
		}  

		/**  
		 *  BBCode: strikethrough  
		 *
		 *  Allowed attributes:
		 *	- style="x"
		 *	- class="x"
		 *
		 *  Code Added by Disturbed One - www.hvmdesign.com  
		 */  
		if($tag === 's')  
		{  
			if( isset($item['params']['style']) )
			{
				$style = $this->valid_style($item['params']['style']);
				if($style === false)
				{
					return $error;
				}
			}
			$extras = $this->allow_styling ? array('style', 'class') : array();  
			$html = '<strike' . $this->add_extras($item['params'], $extras) . '>';  
			return array(  
				'valid'        => true,  
				'start'        => $html,  
				'end'        => '</strike>'  
			);  
		}  

		/**  
		 *  BBCode: hr
		 *
		 *  Allowed attributes:
		 *	- style = " style attributes "
		 *	- class = " CSS class name "
		 *	- align = " left | center | right "
		 *	- width = " percentage | pixels "
		 *	- size = " height in pixels "
		 *	- color = " #RRGGBB | blue "
		 *
		 *  Code Added by Disturbed One - www.hvmdesign.com
		 *
		 *  Code extended by UseLess - Added 'align' and 'width' attributes
		 */  
		if($tag === 'hr')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if( isset($item['params']['style']) )
			{
				$style = $this->valid_style($item['params']['style']);
				if($style === false)
				{
					return $error;
				}
			}
			$extras = $this->allow_styling ? array('style', 'class', 'size', 'color', 'width', 'align') : array();  
			$str = '<hr' . $this->add_extras($item['params'], $extras);  
			return array(  
				'valid'        => true,  
				'start'        => $str,  
				'end'        => ' />'  
			);  
		}  

		/**  
		 *  BBCode: sub  
		 *
		 *  Allowed attributes:
		 *	- style="x"
		 *	- class="x"
		 *
		 *  Code Added by Disturbed One - www.hvmdesign.com  
		 */  
		if($tag === 'sub')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			if( isset($item['params']['style']) )
			{
				$style = $this->valid_style($item['params']['style']);
				if($style === false)
				{
					return $error;
				}
			}
			$extras = $this->allow_styling ? array('style', 'class') : array();  
			$str = '<sub' . $this->add_extras($item['params'], $extras) . '>';  
			return array(  
				'valid'        => true,  
				'start'        => $str,  
				'end'        => '</sub>'  
			);  
		}  

		/**  
		 *  BBCode: sup  
		 *
		 *  Allowed attributes:
		 *	- style="x"
		 *	- class="x"
		 *
		 *  Code Added by Disturbed One - www.hvmdesign.com  
		 */  
		if($tag === 'sup')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			if( isset($item['params']['style']) )
			{
				$style = $this->valid_style($item['params']['style']);
				if($style === false)
				{
					return $error;
				}
			}
			$extras = $this->allow_styling ? array('style', 'class') : array();  
			$str = '<sup' . $this->add_extras($item['params'], $extras) . '>';  
			return array(  
				'valid'        => true,  
				'start'        => $str,  
				'end'        => '</sup>'  
			);  
		} 

		/**  
 		 *    BBCode: Search  
		 *  
		 *  Allowed Attributes:  
		 *  - target = " _self | _blank | _new "  
		 *  
		 *  Code Added by Disturbed One - www.hvmdesign.com  
		 *
		 *  Code extended by UseLess
		 */  
		if($tag === 'search')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			$targets = array('_new', '_self', '_blank');
			if( isset($item['params']['target']) )
			{
				$target = trim($item['params']['target']);
				if(!in_array($target, $targets))
				{
					$target = '_blank';
				}
			}
			else
			{
				$target = '_blank';
			}
			$str = '<a href="search.php?search_keywords=' . urlencode($content) . '" target="' . $target . '">';  
			return array(  
				'valid'	=> true,  
				'start'	=> $str,  
				'end'	=> '</a>'  
			);  
		} 
       
		/**  
		 *  BBCode: ovl  
		 *
		 *  Allowed attributes:
		 *	- style="x"
		 *	- class="x"
		 */  
		if($tag === 'ovl')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			$extras = $this->allow_styling ? array('style', 'class') : array();  
			if( isset($item['params']['style']) )
			{
				$style = $this->valid_style($item['params']['style']);
				if($style === false)
				{
					return $error;
				}
				if( !preg_match('/text-decoration: overline;/i', $item['params']['style']) )
				{
					$item['params']['style'] .= ( (substr($item['params']['style'], -1, 1) !== ';') ? ';' : '') . ' text-decoration: overline;';
				}
			}
			else
			{
				$item['params']['style'] = 'text-decoration: overline;';
			}
			$str = '<span' . $this->add_extras($item['params'], $extras) . '>';  
			return array(  
				'valid'	=> true,  
				'start'	=> $str,  
				'end'	=> '</span>'  
			);  
		} 

		/**    
 		 *  BBCode: mini table    
		 *  
		 *  Code Added by MrBass - www.petesplace-online.co.uk    
		 */    
		if($tag === 'table')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			// check title  
			$title = '';  
			if(isset($item['params']['param']))  
			{  
				$title = htmlspecialchars($item['params']['param']);  
			}
			elseif(isset($item['params']['title'])) 
			{  
				$title = htmlspecialchars($item['params']['title']);  
			}
			// generate html  
			$table_id = substr(md5($content . mt_rand()), 0, 8);
			$str = '<div class="minitable">';
			$str .= '<div class="minitable-header" id="tablehdr2_' . $table_id . '" style="position: relative;"><div class="minitable-hideme">[ <a href="javascript:void(0)" onclick="ShowHide(\'table_' . $table_id . '\', \'table2_' . $table_id . '\', \'\'); ShowHide(\'tablehdr_' . $table_id . '\', \'tablehdr2_' . $table_id . '\', \'\')">' . $lang['xs_bbc_hide'] . '</a> ]</div>' . ( !empty($title) ? $title : '' ) . '</div>';
			$str .= '<div class="minitable-header" id="tablehdr_' . $table_id . '" style="position: relative; display: none;"><div class="minitable-hideme">[ <a href="javascript:void(0)" onclick="ShowHide(\'table_' . $table_id . '\', \'table2_' . $table_id . '\', \'\'); ShowHide(\'tablehdr_' . $table_id . '\', \'tablehdr2_' . $table_id . '\', \'\')">' . $lang['xs_bbc_show'] . '</a> ]</div>' . ( !empty($title) ? $title : '' ) . '</div>';
			$str .= '<div class="minitable-contents" id="table_' . $table_id . '" style="position: relative;">' . $html;
			return array(  
				'valid'	=> true,  
				'start'	=> $str,  
				'end'	=> '</div></div>'  
			);  
		}  

		/**  
		 *  BBCode: countdown  
		 *
		 * Required Attributes:
		 *	- title = " text to show in title "
		 *	- width = " pixels "
		 *	- height = " pixels "
		 *	- target = "01 Jan 200000000 00:00:00 GMT"
		 *	- digits = " 7seg "
		 *
		 * Optional Attributes:
		 *	- endimage = " end1.gif "
		 *	- bgcolor = " rrggbb "
		 *	- fgcolor = " rrggbb "
		 *	- bgimage = " image name (with file ext) "
		 *	- fgimage = " image name (with file ext) "
		 *	- xoffset = " 0 "
		 *	- yoffset = " 0 "
		 *
		 *  Code Added by UseLess  
		 *
		 *  Tag uses the Java Applet released by http://www.demon.net in 1998 the Java Applet
		 *  is (c) 1998 Demon Internet - but can be used in other applications.
		 *
		 *  As stated here:
		 *
		 * "In 1998, as part of Demon Internet's millennium strategy, we launched our
		 *  very own Year 2000 Countdown Clock on this site. After much enthusiastic
		 *  feedback from customers and visitors alike, we have decided to give everyone
		 *  the chance to put this clock on their web site.
		 *
		 *  You don't need to be a customer, you don't even need to be in the UK, and you
		 *  certainly don't have to pay for it or put any credits on your page. It's yours."
		 *
		 */  
		if($tag === 'countdown')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			// Main params
			$params = array(
				'title' => false,
				'width' => false,
				'height' => false,
				'target' => false,
				'digits' => false,
				);
			$params['title'] = ( (isset($item['params']['title']) ) ? trim($item['params']['title']) : '');
			$params['width'] = ( (isset($item['params']['width']) ) ? intval($item['params']['width']) : '');
			$params['height'] = ( (isset($item['params']['height']) ) ? intval($item['params']['height']) : '');
			$params['target'] = ( (isset($item['params']['target']) ) ? $item['params']['target'] : '');
			$params['digits'] = ( (isset($item['params']['digits']) ) ? $item['params']['digits'] : '');
			// Optional Params
			$params['endimage'] = ( (isset($item['params']['endimage']) ) ? $item['params']['endimage'] : '');
			$params['bgimage'] = ( (isset($item['params']['bgimage']) ) ? trim($item['params']['bgimage']) : '');
			$params['fgimage'] = ( (isset($item['params']['fgimage']) ) ? trim($item['params']['fgimage']) : '');
			$params['xoffset'] = ( (isset($item['params']['xoffset']) ) ? intval($item['params']['xoffset']) : '');
			$params['yoffset'] = ( (isset($item['params']['yoffset']) ) ? intval($item['params']['yoffset']) : '');
			$params['bgcolor'] = ( (isset($item['params']['bgcolor']) ) ? trim($item['params']['bgcolor']) : '000000');
			$params['fgcolor'] = ( (isset($item['params']['fgcolor']) ) ? trim($item['params']['fgcolor']) : '00FFFF');
			// Valid Colour?
			$bgcolor = $this->valid_color($params['bgcolor']);
			$fgcolor = $this->valid_color($params['fgcolor']);
			if($bgcolor === false || $fgcolor === false)
			{
				return array(  
					'valid'		=> false,  
					'start'		=> '',  
					'end'		=> ''  
				);
			}
			if( !empty($params['title']) && !empty($params['width']) && !empty($params['height']) && !empty($params['target']) && !empty($params['digits']) )
			{
				$table_id = substr(md5($content . mt_rand()), 0, 8);
				$html = '<div class="countdown">';
				$html .= '<div class="minitable-header" id="tablehdr2_' . $table_id . '" style="position: relative;"><div class="minitable-hideme">[ <a href="javascript:void(0)" onclick="ShowHide(\'table_' . $table_id . '\', \'table2_' . $table_id . '\', \'\'); ShowHide(\'tablehdr_' . $table_id . '\', \'tablehdr2_' . $table_id . '\', \'\')">' . $lang['xs_bbc_hide'] . '</a> ]</div>' . $params['title'] . '</div>';
				$html .= '<div class="minitable-header" id="tablehdr_' . $table_id . '" style="position: relative; display: none;"><div class="minitable-hideme">[ <a href="javascript:void(0)" onclick="ShowHide(\'table_' . $table_id . '\', \'table2_' . $table_id . '\', \'\'); ShowHide(\'tablehdr_' . $table_id . '\', \'tablehdr2_' . $table_id . '\', \'\')">' . $lang['xs_bbc_show'] . '</a> ]</div>' . $params['title'] . '</div>';
				$html .= '<div class="countdown-contents" id="table_' . $table_id . '" style="position: relative;">';
				$html .= '<applet id="countdown_' . $table_id . '" code="jmc.class" codebase="' . $phpbb_root_path . 'classes/java/" width="' . $params['width'] . '" height="' . $params['height'] . '" alt="Countdown Clock">';
				$html .= '<param name="target" value="' . $params['target'] . '">';
				$html .= '<param name="digits" value="' . $phpbb_root_path . 'images/counter/' . $params['digits'] . '">';
				$html .= ( !empty($params['endimage']) ? '<param name="endimage" value="' . $phpbb_root_path . 'images/countdown/' . $params['endimage'] . '">' : '');
				$html .= ( !empty($params['bgimage']) ? '<param name="bgimage" value="' . $phpbb_root_path . 'images/countdown/' . $params['bgimage'] . '">' : '');
				$html .= ( !empty($params['fgimage']) ? '<param name="fgimage" value="' . $phpbb_root_path . 'images/countdown/' . $params['fgimage'] . '">' : '');
				$html .= ( !empty($params['fgcolor']) ? '<param name="fgcol" value="' . $params['fgcolor'] . '">' : '');
				$html .= ( !empty($params['bgcolor']) ? '<param name="bgcol" value="' . $params['bgcolor'] . '">' : '');
				$html .= ( !empty($params['xoffset']) ? '<param name="x" value="' . $params['xoffset'] . '">' : '');
				$html .= ( !empty($params['yoffset']) ? '<param name="y" value="' . $params['yoffset'] . '">' : '');
				$html .= 'You need Java to see this applet!';
				return array(  
					'valid'	=> true,  
					'start'	=> $html,  
					'end'	=> '</applet></div></div>'  
				);
			}
			else
			{
				return array(  
					'valid'	=> false,  
					'start'	=> '',  
					'end'	=> ''  
				);
			}
		} 

		/**  
		 *  BBCode: youtube  
		 *
		 * Required Attributes:
		 *	- src = " src video file "
		 *	- width = " pixels "
		 *	- height = " pixels "
		 *
		 * Optional Attributes:
		 *	- menu = " true | false "
		 *	- quality = " low | high | best " (these could be wrong.. ;) )
		 *	- bgcolor = " #rrggbb | colour name (i.e. red) "
		 *	- loop = " true | false "
		 *	- wmode = " transparent "
		 *	- scale = " noborder "
		 *
		 *  Code Added by UseLess  
		 *
		 *  Code based on youtube BBCode mod by reef_01 < yakaleo@gmail.com >
		 */  
		if($tag === 'youtube')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			// Main params
			$params = array(
				'src' => false,
				'width' => false,
				'height' => false,
				);
			$extras = $this->allow_styling ? array('menu', 'quality', 'bgcolor', 'loop', 'wmode', 'scale') : array();
			$params['src'] = ( (isset($item['params']['src']) ) ? $item['params']['src'] : '');
			$params['width'] = ( (isset($item['params']['width']) ) ? intval($item['params']['width']) : 400);
			$params['height'] = ( (isset($item['params']['height']) ) ? intval($item['params']['height']) : 325);
			if( !empty($params['src']) )
			{
				// generate html  
				$table_id = substr(md5($content . mt_rand()), 0, 8);
				$str = '<div class="minitable">';
				$str .= '<div class="minitable-header" id="tablehdr2_' . $table_id . '" style="position: relative;"><div class="minitable-hideme">[ <a href="javascript:void(0)" onclick="ShowHide(\'table_' . $table_id . '\', \'table2_' . $table_id . '\', \'\'); ShowHide(\'tablehdr_' . $table_id . '\', \'tablehdr2_' . $table_id . '\', \'\')">' . $lang['xs_bbc_hide'] . '</a> ]</div>' . ( !empty($content) ? 'YouTUBE: ' . $content : 'YouTUBE: ' ) . '</div>';
				$str .= '<div class="minitable-header" id="tablehdr_' . $table_id . '" style="position: relative; display: none;"><div class="minitable-hideme">[ <a href="javascript:void(0)" onclick="ShowHide(\'table_' . $table_id . '\', \'table2_' . $table_id . '\', \'\'); ShowHide(\'tablehdr_' . $table_id . '\', \'tablehdr2_' . $table_id . '\', \'\')">' . $lang['xs_bbc_show'] . '</a> ]</div>' . ( !empty($content) ? 'YouTUBE: ' . $content : 'YouTUBE: ' ) . '</div>';
				$str .= '<div class="minitable-contents" id="table_' . $table_id . '" style="position: relative;"><center>';

				$str .= '<object width="' . $params['width'] . '" height="' . $params['height'] . '">';
				$str .= '<param name="allowScriptAccess" value="never" />';
				$str .= '<param name="movie" value="http://www.youtube.com/v/' . $params['src'] . '" />';
				$str .= $this->add_object_extras($item['params'], $extras);
				$str .= '<embed allowScriptAccess="never" src="http://www.youtube.com/v/' . $params['src'] . '" width="' . $params['width'] . '" height="' . $params['height'] . '"' . $this->add_extras($item['params'], $extras) . '>';  
				$str .= '</embed></object><br /><a href="http://www.youtube.com/watch?v=' . $params['src'] . '" target="_blank">Link</a></center></div></div>';
				return array(  
					'valid'		=> true,  
					'html'		=> $str,  
					'allow_nested'	=> false  
				);
			}
			else
			{
				return array(  
					'valid'	=> false,  
					'start'	=> '',  
					'end'	=> ''  
				);
			}
		} 

		/**  
 		 *    BBCode: tab  
		 *  
		 *  Code Added by UseLess
		 */  
		if($tag === 'tab')  
		{  
			if($this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			$html = '<pre style="display: inline">    ';
			return array(  
				'valid'	=> true,  
				'start'	=> $html,  
				'end'	=> '</pre>'  
			);  
		} 

		/**  
		 *  BBCode: rquote  
		 *
		 *  Code Added by UseLess
		 */  
		if($tag === 'rquote')  
		{  
			if(!$this->is_sig)  
			{  
				return $error;  
			}  
			if($item['iteration'] > $this->nest_level)  
			{  
				return $error;  
			}  
			$script_name = preg_replace('/^\/?(.*?)\/?$/', '\1', trim($board_config['script_path']));
			$script_name = ($script_name != '') ? $script_name . '/includes/rand_quote.'.$phpEx : 'includes/rand_quote.'.$phpEx;
			$server_name = trim($board_config['server_name']);
			$server_protocol = ($board_config['cookie_secure']) ? 'https://' : 'http://';
			$server_port = ($board_config['server_port'] <> 80) ? ':' . trim($board_config['server_port']) . '/' : '/';
			$html = '<script language="javascript" type="text/javascript" src="' . $server_protocol . $server_name . $server_port . $script_name . '" />';
			return array(  
				'valid'		=> true,  
				'start'		=> $html,  
				'end'		=> '</script>'  
			);
		} 

		/**
		*	Invalid tag
		*/
		return $error;
	}

	/**
	 *	Check if bbcode tag is valid
	 */
	function valid_tag($tag, $is_html)
	{
		if($is_html)
		{
			return (isset($this->allowed_html[$tag]) && preg_match('/^[a-z]+$/', $tag)) ? true : false;
		}
		else
		{
			return (isset($this->allowed_bbcode[$tag]) && (preg_match('/^[a-z]+$/', $tag) || $tag === '*')) ? true : false;
		}
	}

	/**
	 *	Check if parameter name is valid
	 */
	function valid_param($param)
	{
		return preg_match('/^[a-z]+$/', $param);
	}

	/**
	 *	Check if color is valid
	 */
	function valid_color($color)
	{
		$color = strtolower($color);
		if(preg_match('/^[a-z]+$/', $color))
		{
			// text color
			return $color;
		}
		if(substr($color, 0, 1) === '#')
		{
			// normal color
			if(preg_match('/^[0-9a-f]+$/', substr($color, 1)))
			{
				if(strlen($color) == 4 || strlen($color) == 7)
				{
					return $color;
				}
			}
			return false;
		}
		// rgb color
		if(substr($color, 0, 4) === 'rgb(' && preg_match('/^rgb\([0-9]+,[0-9]+,[0-9]+\)$/', $color))
		{
			$colors = explode(',', substr($color, 4, strlen($color) - 5));
			for($i=0; $i<3; $i++)
			{
				if($colors[$i] > 255)
				{
					return false;
				}
			}
			return sprintf('#%02X%02X%02X', $colors[0], $colors[1], $colors[2]);
		}
		// color with missing #
		if(preg_match('/^[0-9a-f]+$/', $color))
		{
			if(strlen($color) == 3 || strlen($color) == 6)
			{
				return '#' . $color;
			}
		}
		return false;
	}

	/**
	 *	Parse style
	 */
	function valid_style($style, $error = false)
	{
		$style = str_replace(array('\\', '"', '@'), array('','',''), $style);
		$str = strtolower($style);
		if(strpos($str, 'expression') !== false || strpos($str, 'javascript:') !== false || strpos($str, 'vbscript:') !== false || strpos($str, 'about:') !== false)
		{
			// attempt to use javascript
			return $error;
		}
		if(strpos($str, '//') !== false)
		{
			// attempt to use external file
			return $error;
		}
		if(strpos($str, '!important') !== false)
		{
			// attempt to completely mess up forum layout?
			return $error;
		}
		return $style;
	}

	/**
	 *	Validate url
	 */
	function valid_url($url, $error = '')
	{
		$str = strtolower($url);
		if(substr($str, 0, 11) === 'javascript:')
		{
			// attempt to use javascript
			return $error;
		}
		if(substr($str, 0, 9) === 'vbscript:')
		{
			// attempt to use vbscript
			return $error;
		}
		if(substr($str, 0, 6) === 'about:')
		{
			// attempt to use about: url
			return $error;
		}
		return $url;
	}

	/**
	 *	Check a URL to see if it's local or remote
	 */
	function check_url($url, $mode)
	{
		global $urls_local, $allowed_urls;
		
		switch( $mode )
		{
			case 'local':
				$url_local = false;
				for($i=0; $i<count($urls_local); $i++)
				{
					if(strlen($url) >= strlen($urls_local[$i]) && strpos($url, $urls_local[$i]) === 0)
					{
						$url_local = true;
						$url = substr($url, strlen($urls_local[$i]));
						break;
					}
				}
				if(!$url_local)
				{
					if(strpos($url, ':') === false)
					{
						$url_local = true;
					}
				}
				return $url_local;
			
				break;
			
			case 'allowed':
				$allowed_url = false;
				for($i=0; $i<count($allowed_urls); $i++)
				{
					if(strlen($url) >= strlen($allowed_urls[$i]) && strpos($url, $allowed_urls[$i]) === 0)
					{
						$allowed_url = true;
						break;
					}
					elseif(substr($url, strpos($url, '.'), strlen($allowed_urls[$i])) == $allowed_urls[$i])
					{
						$allowed_url = true;
						break;
					}
				}
				return $allowed_url;
				
				break;
		}
		
		// if this point is reached then it's an invalid mode so...
		return false;
	} // end check_url
	
	/**
	 *	Add extras
	 */
	function add_extras($params, $extras)
	{
		$html = '';
		for($i=0; $i<count($extras); $i++)
		{
			if(isset($params[$extras[$i]]))
			{
				if($extras[$i] === 'style')
				{
					$style = $this->valid_style($params['style']);
					if($style !== false)
					{
						$html .= ' style="' . htmlspecialchars($style) . '"';
					}
				}
				else
				{
					$html .= ' ' . $extras[$i] . '="' . htmlspecialchars($params[$extras[$i]]) . '"';
				}
			}
		}
		return $html;
	}
	/**
	 *	Add object extras
	 */
	function add_object_extras($params, $extras)
	{
		$html = '';
		for($i=0; $i<count($extras); $i++)
		{
			if(isset($params[$extras[$i]]))
			{
				$html .= '<param name="' . $extras[$i] . '" value="' . htmlspecialchars($params[$extras[$i]]) . '" />';
			}
		}
		return $html;
	}
	/**
	 *	Splits string to tag and parameters
	 */
	function extract_params($tag, $is_html)
	{
		$this->tag = $tag;
		$this->params = array();
		$tag = str_replace("\t", ' ', $tag);
		// get parameters
		$pos_eq = strpos($tag, '=');
		$pos_space = strpos($tag, ' ');
		if($pos_space !== false && $pos_eq !== false && $pos_space < $pos_eq)
		{
			// mutiple parameters
			$param_start = 0;
			$param_str = substr($tag, $pos_space + 1);
			$param_len = strlen($param_str);
			$this->tag = strtolower(substr($tag, 0, $pos_space));
			if(!$this->valid_tag($this->tag, $is_html))
			{
				return false;
			}
			while($param_start < $param_len)
			{
				// find entry for '='
				$pos = strpos($param_str, '=', $param_start);
				if($pos === false)
				{
					return false;
				}
				else
				{
					// get parameter name
					$str = substr($param_str, $param_start, $pos - $param_start);
					if(!$this->valid_param($str))
					{
						return false;
					}
					// get value
					$pos++;
					$quoted = false;
					if(substr($param_str, $pos, 1) === '"')
					{
						$pos2 = strpos($param_str, '"', $pos + 1);
						if($pos2 === false)
						{
							// invalid quote. search for space instead
							$pos2 = strpos($param_str, ' ', $pos + 1);
						}
 						else
						{
							$pos++;
							$quoted = true;
						}
					}
					else
					{
						$pos2 = strpos($param_str, ' ', $pos);
					}
					// end not found. counting until end of expression
					if($pos2 === false)
					{
						$pos2 = $param_len;
					}
					$this->params[$str] = substr($param_str, $pos, $pos2 - $pos);
					$param_start = $pos2 + 1;
					if($quoted)
					{
						$param_start ++;
					}
				}
			}
		}
		elseif($pos_eq !== false)
		{
			// single parameter
			$str = substr($tag, $pos_eq + 1);
			$this->tag = strtolower(substr($tag, 0, $pos_eq));
			if(!$this->valid_tag($this->tag, $is_html))
			{
				return false;
			}
			if(strlen($str) > 1 && substr($str, 0, 1) === '"' && substr($str, strlen($str) - 1) === '"')
			{
				$str = substr($str, 1, strlen($str) - 2);
			}
			if(trim($str) !== $str)
			{
				return false;
			}
			$this->params['param'] = $str;
		}
		else
		{
			// no parameters
			$this->tag = strtolower($tag);
			if(!$this->valid_tag($this->tag, $is_html))
			{
				return false;
			}
		}
		return true;
	}

	/**
	 *	Recusive function that converts text to bbcode tree
	 */
	function push($start, $level, $prev_tags)
	{
		$items = array();
		$pos_start_bbcode = $this->allow_bbcode ? strpos($this->text, '[', $start) : false;
		$pos_start_html = $this->allow_html ? strpos($this->text, '<', $start) : false;
		while($pos_start_bbcode !== false || $pos_start_html !== false)
		{
			$pos_start = $pos_start_bbcode === false ? $pos_start_html : ($pos_start_html === false ? $pos_start_bbcode : min($pos_start_bbcode, $pos_start_html));
			$is_html = $pos_start_html === $pos_start ? true : false;
			$prev_start = $start;
			// found tag. get data.
			$pos_end = strpos($this->text, $is_html ? '>' : ']', $pos_start);
			if($pos_end === false)
			{
				$tag_valid = false;
			}
			else
			{
				$code = substr($this->text, $pos_start, $pos_end - $pos_start + 1);
				// check if tag is valid and get type of tag
				$tag_valid = true;
				$tag_closing = false;
				$tag_self_closing = false;
				if(strlen($code) < 3)
				{
					$tag_valid = false;
				}
				elseif(!$is_html && strpos($code, '[', 1) !== false)
				{
					$tag_valid = false;
				}
				elseif($is_html && strpos($code, '<', 1) !== false)
				{
					$tag_valid = false;
				}
				elseif(!$is_html && strpos($code, "\n") !== false)
				{
					$tag_valid = false;
				}
				elseif(substr($code, 0, 2) === ($is_html ? '</' : '[/'))
				{
					$tag_closing = true;
					$tag = substr($code, 2, strlen($code) - 3);
				}
				elseif(substr($code, strlen($code) - 3) === ($is_html ? ' />' : ' /]'))
				{
					$tag_self_closing = true;
					$tag = substr($code, 1, strlen($code) - 4);
				}
				else
				{
					$tag = substr($code, 1, strlen($code) - 2);
				}
				// do not process tag if it requires too much recursion
				if($level > 10 && (!$tag_closing && !$tag_self_closing))
				{
					$tag_valid = false;
				}
				// special tags
				if($code === '[*]')
				{
					$tag_self_closing = true;
				}
			}
			if($tag_valid)
			{
				$start = $pos_end;
				$params = array();
				if(!$tag_closing)
				{
					if(!$this->extract_params($tag, $is_html))
					{
						$tag_valid = false;
					}
					else
					{
						$tag = $this->tag;
						$params = $this->params;
					}
				}
				else
				{
					if(strpos($tag, ' autourl=' . AUTOURL))
					{
						$tag = str_replace(' autourl=' . AUTOURL, '', $tag);
					}
					$tag = strtolower($tag);
					if(!$this->valid_tag($tag, $is_html))
					{
						$tag_valid = false;
					}
				}
			}
			if($tag_valid)
			{
				if($tag_closing)
				{
					// check if this is correct closing tag
					if(in_array($tag, $prev_tags))
					{
						return array(
							'items'	=> $items,
							'tag'	=> $tag,
							'pos'	=> $pos_end,
							'start'	=> $pos_start,
							'len'	=> strlen($code)
							);
					}
				}
				elseif($tag_self_closing)
				{
					// found self-closing tag
					$items[] = array(
						'tag'		=> $tag,
						'code'		=> $code,
						'params'	=> $params,
						'start'		=> $pos_start,
						'start_len'	=> strlen($code),
						'end'		=> $pos_end + 1,
						'end_len'	=> 0,
						'level'		=> $level + 1,
						'iteration'	=> 0,
						'self_closing'	=> 1,
						'prev'		=> array(),
						'next'		=> array(),
						'is_html'	=> $is_html,
						'items'		=> array()
						);
				}
				else
				{
					// found correct tag. call recursive search
					$result = $this->push($pos_end, $level + 1, array_merge($prev_tags, array($tag)));
					if($result['tag'] === $tag)
					{
						// found correctly finished tag
						$items[] = array(
							'tag'		=> $tag,
							'code'		=> $code,
							'params'	=> $params,
							'start'		=> $pos_start,
							'start_len'	=> strlen($code),
							'end'		=> $result['start'],
							'end_len'	=> $result['len'],
							'level'		=> $level + 1,
							'iteration'	=> 0,
							'self_closing'	=> 2,
							'prev'		=> array(),
							'next'		=> array(),
							'is_html'	=> $is_html,
							'items'		=> $result['items']
							);
						$start = $result['pos'];
					}
					else
					{
						$items = array_merge($items, $result['items']);
						return array(
							'items'	=> $items,
							'tag'	=> $result['tag'],
							'pos'	=> $result['pos'],
							'start'	=> $result['start'],
							'len'	=> $result['len']
							);
					}
				}
			}
			else
			{
				$start = $pos_start + 1;
			}
			$pos_start_bbcode = $this->allow_bbcode ? strpos($this->text, '[', $start) : false;
			$pos_start_html = $this->allow_html ? strpos($this->text, '<', $start) : false;
		}
		return array(
			'items'	=> $items,
			'tag'	=> false,
			);
	}

	/**
	 *	Debug fuction. Prints tree of bbcode
	 */
	function debug($items)
	{
		for($i=0; $i<count($items); $i++)
		{
			$item = $items[$i];
			if($item['tag'])
			{
				for($j=0; $j<$item['level']; $j++)
				{
					echo '-';
				}
				echo ' ', $item['tag'], ' (';
				$first = true;
				foreach($item['params'] as $var => $value)
				{
					if(!$first) echo ', ';
					$first = false;
					echo $var, '="', htmlspecialchars($value), '"';
				}
				echo ")<br />\n";
				$this->debug($item['items']);
			}
		}
	}

	/**
	 *	Post-processing. Adds previous/next items to every item.
	 */
	function add_pointers(&$items, $prev_tags)
	{
		$tags = array();
		for($i=0; $i<count($items); $i++)
		{
			$item = &$items[$i];
			$tags[] = array(
				'tag'	=> $item['tag'],
				'item'	=> &$items[$i]
				);
			$iterations = 0;
			for($j=0; $j<count($prev_tags); $j++)
			{
				if($prev_tags[$j]['tag'] === $item['tag'])
				{
					$iterations++;
				}
			}
			$item['iteration'] = $iterations;
			$item['prev'] = $prev_tags;
			// todo: check if subitems are allowed
			// parse sub-items
			if(count($item['items']))
			{
				$arr = array(
					'tag'	=> $item['tag'],
					'item'	=> &$items[$i]
					);
				$item['next'] = $this->add_pointers($item['items'], array_merge($prev_tags, array($arr)));
				$tags = array_merge($tags, $item['next']);
			}
		}
		return $tags;
	}

	/**
	 *	Process text
	 */
	function process_text($text, $br = true, $chars = true)
	{
		$search = array(
			'[url autourl=' . AUTOURL . ']',
			'[/url autourl=' . AUTOURL  .']',
			'[email autourl=' . AUTOURL . ']',
			'[/email autourl=' . AUTOURL  .']'
		);
		$replace = array('','','','');
		$text = str_replace($search, $replace, $text);
		if($chars)
		{
			$text = htmlspecialchars($text);
			$text = str_replace('&amp;#', '&#', $text);
		}
		else
		{
			$text = str_replace(
					array('&amp;', '>', '<', '"', '&amp;#'),
					array('&amp;amp;', '&gt;', '&lt;', '&quot;', '&#'),
				$text);
		}
		if($br)
		{
			$text = str_replace("\n", "<br />\n", $text);
		}
		return $text;
	}

	/**
	 *	Process tree
	 */
	function process($start, $end, &$items)
	{
		$html = '';
		for($i=0; $i<count($items); $i++)
		{
			$item = &$items[$i];
			// check code before item
			if($item['start'] > $start)
			{
				$html .= $this->process_text(substr($this->text, $start, $item['start'] - $start));
			}
			// process tag
			$result = $this->process_tag($item);
			if($result['valid'] && !isset($result['html']))
			{
				$html .= $result['start'];
				if(!isset($result['allow_nested']) || $result['allow_nested'])
				{
					// process code inside tag
					$html .= $this->process($item['start'] + $item['start_len'], $item['end'], $item['items']);
				}
				$html .= $result['end'];
			}
			elseif($result['valid'])
			{
				$html .= $result['html'];
			}
			else
			{
				// invalid tag. show html code for it and process nested tags
				$item['valid'] = false;
				if($item['start_len'])
				{
					$html .= $this->process_text(substr($this->text, $item['start'], $item['start_len']));
				}
				$html .= $this->process($item['start'] + $item['start_len'], $item['end'], $item['items']);
				if($item['end_len'])
				{	
					$html .= $this->process_text(substr($this->text, $item['end'], $item['end_len']));
				}
			}
			$start = $item['end'] + $item['end_len'];
		}
		// process code after item
		if($start < $end)
		{
			$html .= $this->process_text(substr($this->text, $start, $end - $start));
		}
		return $html;
	}

	/**
	 *	Prepare smilies list
	 */
	function prepare_smilies()
	{
		if(!$this->allow_smilies)
		{
			return;
		}
		$this->replaced_smilies = array();
		for($i=0; $i<count($this->allowed_smilies); $i++)
		{
			if(strpos($this->text, $this->allowed_smilies[$i]['code']) !== false)
			{
				$this->replaced_smilies[] = $this->allowed_smilies[$i];
			}
		}
	}

	/**
	 *	Process smilies
	 */
	function process_smilies()
	{
		$valid_chars_prev = array('', ' ', "\n", "\r", "\t", '>');
		$valid_chars_next = array('', ' ', "\n", "\r", "\t", '<');
		if(!$this->allow_smilies && !count($this->replaced_smilies))
		{
			return;
		}
		for($i=0; $i<count($this->replaced_smilies); $i++)
		{
			$code = $this->replaced_smilies[$i]['code'];
			$text = $this->replaced_smilies[$i]['replace'];
			$code_len = strlen($code);
			$text_len = strlen($text);
			$pos = strpos($this->html, $code);
			while($pos !== false)
			{
				$valid = false;
				// check previous character
				$prev_char = $pos > 0 ? substr($this->html, $pos - 1, 1) : '';
				if(in_array($prev_char, $valid_chars_prev))
				{
					// check next character
					$next_char = substr($this->html, $pos + $code_len, 1);
					if(in_array($next_char, $valid_chars_next))
					{
						// make sure we aren't inside html code
						$pos1 = strpos($this->html, '<', $pos + $code_len);
						$pos2 = strpos($this->html, '>', $pos + $code_len);
						if($pos2 === false || ($pos1 && $pos1 < $pos2))
						{
							// make sure we aren't inside nosmilies zone
							$pos1 = strpos($this->html, BBCODE_NOSMILIES_START, $pos + $code_len);
							$pos2 = strpos($this->html, BBCODE_NOSMILIES_END, $pos + $code_len);
							if($pos2 === false || ($pos1 && $pos1 < $pos2))
							{
								$valid = true;
							}
						}
					}
				}
				if($valid)
				{
					$this->html = substr($this->html, 0, $pos) . $text . substr($this->html, $pos + $code_len);
					$pos += $text_len;
					$this->smilie_counter++;
				}
				else
				{
					$pos ++;
				}
				$pos = strpos($this->html, $code, $pos);
			}
		}
	}

	/**
	 *	Make urls clickable
	 */
	function process_urls()
	{
		// characters allowed in email
		$chars = array();
		for($i=224; $i<256; $i++)
		{
			if($i != 247)
			{
				$chars .= chr($i);
			}
		}
		// search and replace arrays
		$search = array(
			"/([\s>])((https?|ftp):\/\/|www\.)([^ \r\n\(\)\^\$!`\"'\|\[\]\{\}<>]+)/si",
			"/([\s>])([_a-zA-Z0-9\-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9\-{$chars}]+(\.[a-zA-Z0-9\-{$chars}]+)*(\.[a-zA-Z]{2,}))/si",
		);
		$replace = array(
			"\\1[url autourl=" . AUTOURL . "]\\2\\4[/url autourl=" . AUTOURL . "]",
			"\\1[email autourl=" . AUTOURL . "]\\2[/email autourl=" . AUTOURL . "]",
		);
	 	$this->text = preg_replace($search, $replace, ' ' . $this->text . ' ');
		$this->text = substr($this->text, 1, strlen($this->text) - 2);
	}

	/**
	 *	Converts text to html code
	 */
	function parse($text, $id = false)
	{
		if(defined('IN_PHPBB'))
		{
			$search = array(
				$id ? ':' . $id : '',
				'code:1]',
				'list:o]',
				);
			$replace = array(
				'',
				'code]',
				'list]',
				);
			$text = str_replace($search, $replace, $text);
			if($id)
			{
				$text = undo_htmlspecialchars($text);
			}
		}
		// reset variables
		$this->text = $text;
		$this->data = array();
		$this->html = '';
		$this->prepare_smilies();
		$this->process_urls();
		$this->code_counter = 0;
		$this->img_counter = 0;
		$this->smilie_counter = 0;
		// if bbcode and html are disabled then return unprocessed text
		if(!$this->allow_bbcode && !$this->allow_html)
		{
			$this->html = $this->text;
			$this->process_smilies();
			return $this->html;
		}
		// convert to tree structure
		$result = $this->push(0, 0, array());
		$this->data = $result['items'];

		// Dump debug info if enabled
		if( $this->debug_enable )
		{
			ob_start();
			$this->debug($this->data);
			$str = ob_get_contents();
			ob_end_clean();
			$this->html = 'Debug:<br />' . $str;
			return $this->html;
		}
		
		// add prev/next pointers and count iterations
		$this->add_pointers($this->data, array());
		// convert to html
		$this->html = $this->process(0, strlen($this->text), $this->data);
		$this->process_smilies();
	
		return $this->html;
	}

}
//
// End BBCode Class Definition
//

//
// Start Function Block
//
function make_bbcode_uid()
{
	// Unique ID for this message..
	$uid = dss_rand();
	$uid = substr($uid, 0, BBCODE_UID_LEN);
	return $uid;
}

function undo_htmlspecialchars($input, $full_undo = false)
{
	if($full_undo)
	{
		$input = str_replace('&nbsp;', '', $input);
	}
	$input = preg_replace("/&gt;/i", ">", $input);
	$input = preg_replace("/&lt;/i", "<", $input);
	$input = preg_replace("/&quot;/i", "\"", $input);
	$input = preg_replace("/&amp;/i", "&", $input);
	if($full_undo)
	{
		if(preg_match_all('/&\#([0-9]+);/', $input, $matches) && count($matches))
		{
			$list = array();
			for($i=0; $i<count($matches[1]); $i++)
			{
				$list[$matches[1][$i]] = true;
			}
			$search = array();
			$replace = array();
			foreach($list as $var => $value)
			{
				$search[] = '&#' . $var . ';';
				$replace[] = chr($var);
			}
			$input = str_replace($search, $replace, $input);
		}
	}
	return $input;
}

if( !function_exists('Multi_BBCode') )
{
	// MULTI BBCODE-begin
	// The following function has been updated to include the 'button' code
	function Multi_BBCode()
	{
		global $template, $lang;
		// DO NOT CHANGE THIS ARRAY
		$hotkeys = array('', 'd', 'e', 'g', 'h', 'j', 'k', 'm', 'n', 'r', 't', 'v', 'x', 'y', 'z', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0');
		//NOTE: the first element of each array must be ''   Add new elements AFTER the ''
		$EMBB_widths = array('', '30', '30', '40', '40', '40', '50','75','50','50','50','50','75','50','45','55') ;
		$EMBB_values = array('',' S ', ' HR ', ' Sup ', ' Sub ', ' Ovl ', 'Spoil','Spoiler','You','Flash','Align','Hide','Marquee','Table','Tab','RQuote') ;
		$max_rows = ((count($EMBB_values)-1)/9) ;
		$max_rows = ($max_rows*9 == count($EMBB_values)) ? $max_rows : $max_rows+1 ;
		$code_count = 1 ;
		for ($i=1; $i<=$max_rows; $i++)
		{
			$template->assign_block_vars('XBBcode', array(
				'ROW_ID' => $i)
			);
			for ($element=0; $element<9; $element++)
			{
				$val = ($code_count*2)+16 ;
				if ( $code_count < count($EMBB_values))
				{
					$help_lang = ( !empty($lang['bbcode_help'][(strtolower(trim($EMBB_values[$code_count])))]) ) ? $lang['bbcode_help'][(strtolower(trim($EMBB_values[$code_count])))] : $lang['bbcode_help'][trim($EMBB_values[$code_count])];
					$template->assign_block_vars('XBBcode.BB', array(
						'KEY' => $hotkeys[$code_count],
						'NAME' => "addbbcode$val",
						'HELP' => sprintf($help_lang, $hotkeys[$code_count]), 
						'WIDTH' => $EMBB_widths[$code_count],
						'VALUE' => trim($EMBB_values[$code_count]),
						'STYLE' => "bbstyle($val)")
					);
				}
				$code_count++ ;
			}
		}
	}
	// MULTI BBCODE-end
}
//
// End function Block
//

// Init bbcode class
$xs_bbcode = new BBCode();

// Need to initialize the random numbers only ONCE
mt_srand( (double) microtime() * 1000000);

if ( defined('SMILIES_TABLE') )
{
	//
	// Get smilies from DB and assign to class array
	//
	$sql = "SELECT * FROM " . SMILIES_TABLE;
	if(($result = $db->sql_query($sql)) !== false)
	{
		$smilies = $db->sql_fetchrowset($result);
		$xs_bbcode->allowed_smilies = array();
		for($i=0; $i<count($smilies); $i++)
		{
			// Altered the Smilie path as this can be changed in the forum config...
			// As pointed out by MrBass.. and also added a check to see if / is at the end of the path
			$arr = array(
				'code'		=> $smilies[$i]['code'],
				'replace'	=> '<img src="' . $board_config['smilies_path'] . ( (substr($board_config['smilies_path'], strlen($board_config['smilies_path']) -1) == '/') ? '' : '/') . $smilies[$i]['smile_url'] . '" alt="' . htmlspecialchars($smilies[$i]['emoticon']) . '" />'
			);
			$xs_bbcode->allowed_smilies[] = $arr;
		}
	}
}

?>